/*
 *  ******************************************************************************
 *  *
 *  *
 *  * This program and the accompanying materials are made available under the
 *  * terms of the Apache License, Version 2.0 which is available at
 *  * https://www.apache.org/licenses/LICENSE-2.0.
 *  *
 *  *  See the NOTICE file distributed with this work for additional
 *  *  information regarding copyright ownership.
 *  * Unless required by applicable law or agreed to in writing, software
 *  * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 *  * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 *  * License for the specific language governing permissions and limitations
 *  * under the License.
 *  *
 *  * SPDX-License-Identifier: Apache-2.0
 *  *****************************************************************************
 */
package com.atilika.kuromoji.compile;

import com.atilika.kuromoji.trie.DoubleArrayTrie;
import com.atilika.kuromoji.trie.Trie;

import java.util.List;

public class DoubleArrayTrieCompiler {

    public static DoubleArrayTrie build(List<String> surfaces, boolean compact) {
        Trie trie = new Trie();

        for (String surface : surfaces) {
            trie.add(surface);
        }
        DoubleArrayTrie doubleArrayTrie = new DoubleArrayTrie(compact);
        doubleArrayTrie.build(trie);

        return doubleArrayTrie;
    }
}
